import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
import java.awt.Color;
/**
 * Write a description of class Board here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Board  extends Actor
{
    private GreenfootImage image = new GreenfootImage("boardBg.png");
    private String text;
    private boolean opaque;
    private boolean clicked;
   
    public Board(String text)
    {
        if(MyWorld.timerValue >= 15 && !MyWorld.solutionPressed)
        {
            Ship.lives++;
            image.setFont(new Font("Serif", 1, 40));
            image.setColor(Color.YELLOW);
            image.drawString("Bonus! +1 life", 15, 240);
        }
        if(MyWorld.solutionPressed)
        {
            MyWorld.score = MyWorld.score-100;
            MyWorld.solutionPressed = false;
        }
        else if(text == "Waste transferred...")
        {
            MyWorld.score = MyWorld.score+MyWorld.timerValue;
        }
        else if(text == "You defeated the Martians!")
        {
            MyWorld.score = MyWorld.score+Ship.lives*50;
        }
        this.text = text;
        MyWorld.movePipes = false;
        image.setFont(new Font("Serif", 1, 72));
        image.setColor(Color.WHITE);
        image.drawString("Victory!", 15, 75);
        image.setFont(new Font("Serif", 1, 40));
        image.drawString(text, 15, 135);
        image.setColor(Color.YELLOW);
        image.drawString("Score: "+MyWorld.score, 15, 190);
        image.setColor(Color.WHITE);
        image.setFont(new Font("Serif", 1, 18));
        image.drawString("Click to continue...", 300, 200);
        image.setTransparency(0);
        opaque = false;
        clicked = false;
    }


    public void act() 
    {
        if(opaque == false)
        {
            if(image.getTransparency() == 255)
            {
                opaque = true;
            }
            else
            {
                image.setTransparency(image.getTransparency()+5);
                setImage(image);
            }
        }
        if(Greenfoot.mouseClicked(this))
        {
            clicked = true;
        }
        if(clicked == true && text == "You defeated the Martians!")
        {
            if(opaque == true)
            {
                if(image.getTransparency() == 0)
                {
                    opaque = false;
                    MyWorld world = (MyWorld) getWorld();
                    world.spaceWin(world.currentLvl);
                }
                else
                {
                    image.setTransparency(image.getTransparency()-5);
                    setImage(image);
                }
            }
        }
        if(clicked == true && text == "Waste transferred...")
        {
            if(opaque == true)
            {
                if(image.getTransparency() == 0)
                {
                    opaque = false;
                    MyWorld world = (MyWorld) getWorld();
                    world.oilWin(world.currentLvl);
                }
                else
                {
                    image.setTransparency(image.getTransparency()-5);
                    setImage(image);
                }
            }
        }
    }    
}
