import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class HoritzantalCounter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class DownLeft  extends Pipes
{
   public DownLeft(int i)
   {
       Greenfoot.playSound("build.wav");
    }
    
    public DownLeft()
    {}

    public void snap()
    {
        Actor h = getOneObjectAtOffset(-50, 0, Horizantal.class);
        Actor dr = getOneObjectAtOffset(-50, 0, DownRight.class);
        Actor ur = getOneObjectAtOffset(-50, 0, UpRight.class);
        Actor ul = getOneObjectAtOffset(0, 50, UpLeft.class);
        Actor beg = getOneObjectAtOffset(-50, 0, Beg.class);
        if(h != null)
        {
            setLocation(h.getX()+59, h.getY()+8);
        }
        else if(beg != null)
        {
            setLocation(beg.getX()+59, beg.getY()+8);
        }
        else if(dr != null)
        {
            setLocation(dr.getX()+50, dr.getY()-2);
        }
        else if(ur != null)
        {
            setLocation(ur.getX()+55, ur.getY()+17);
        }
        else if(ul != null)
        {
            setLocation(ul.getX()-1, ul.getY()-50);
        }
    }
    
    public void act() 
    {
        checkMouse();
        snap();
        outsideField();
    }    
    
    public void outsideField()
    {
        Actor o = getOneIntersectingObject(Obstacle.class);
        if(getX() >= 700-getImage().getWidth()/2 || o != null)
        {
            getWorld().addObject(new DownLeftDummy(), MyWorld.Px, MyWorld.DLy);
            getWorld().removeObject(this);
        }
    }
    
    public void checkMouse()
    {
        if(Greenfoot.mouseDragged(this) && MyWorld.movePipes)
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            setLocation(mouse.getX(), mouse.getY());
        }
    }
}
