import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemy  extends Wanderer
{
    private int health;
    private int speed;
    private final int WAIT_TIME = 300;
    private int transparencyNum;
    
    public Enemy(int health, int speed)
    {
        this.health = health;
        this.speed = speed;
        transparencyNum = 255/health;
    }

    /**
     * Act - do whatever the Enemy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        
        setLocation(getX()-speed, getY());
        checkHit();
        atEdge();
    }    
    
    public void atEdge()
    {
        if(getX() <= 0)
        {
            setLocation(getWorld().getWidth()+getImage().getWidth()+WAIT_TIME, getY());
        }
    }
    
    public void checkHit()
    {
        Actor bullet = getOneIntersectingObject(Bullet.class);
        if(bullet != null)
        {
            getWorld().removeObject(bullet);
            health--;
            if(health <= 0)
            {
                MyWorld.score = MyWorld.score+20;
                getWorld().removeObject(this);
            }
            else
            {
                MyWorld.score = MyWorld.score+5;
                GreenfootImage image = getImage();
                image.setTransparency(image.getTransparency()-transparencyNum);
                setImage(image);
            }
        }
    }
}
