import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot) 
import java.awt.Color;
import java.awt.Font;
import java.util.List;
/**
 * A class that has a scrolling background image
 * 
 * @author Poul Henriksen
 */
public class MyWorld extends World 
{ 
    private static final GreenfootImage bg = new GreenfootImage("bg.jpg");
    private static final GreenfootImage bgImage = new GreenfootImage("space1.gif");
    private static final int scrollSpeed = 1;
    private GreenfootImage scrollingImage;
    private int scrollPosition = 0;
    
    public static String text = "";
    
    public static int score = 0;
    public static boolean solutionPressed = false;
    
    //level passwords
    public static String pass1 = "3dKy";
    public static String pass2 = "lMK9";
    public static String pass3 = "I1yu";
    public static String pass4 = "8Jm6";
    public static String pass5 = "RPim";
    public static String pass6 = "TuuE";
    public static String pass7 = "U1eW";
    public static String pass8 = "uQK1";
    public static String pass9 = "pSUx";
    public static String pass10 = "La5E";
    
    
    //number of enemies for each space level
    private int enemies1 = 10;
    private int enemies2 = 10;
    private int enemies3 = 15;
    private int enemies4 = 15;
    private int enemies5 = 20;
    private int enemies6 = 20;
    private int enemies7 = 25;
    private int enemies8 = 25;
    private int enemies9 = 30;
    private int enemies10 = 50;
 
    public static int waste = 10;
    
    public static int timerValue;
    
    //time limits for each level
    private static final int timer1 = 100;
    private static final int timer2 = 50;
    private static final int timer3 = 50;
    private static final int timer4 = 50;
    private static final int timer5 = 45;
    private static final int timer6 = 55;
    private static final int timer7 = 70;
    private static final int timer8 = 70;
    private static final int timer9 = 70;
    private static final int timer10 = 80;
    
    public static int currentLvl = 1;
    
    //only move pipes when this is true
    public static boolean movePipes;
    
    //if you win at the pipe game
    public static boolean oilWin = false;
    
    //if the timer should count down
    public static boolean timerCount = true;
    
    //numbers of each dummy pipe for each level
    //oh and for each level's waste rocket's coordinates
    private static final int lvl1H = 8;
    private static final int lvl1Rx = 600;
    private static final int lvl1Ry = 200;
    
    private static final int lvl2Rx = 617;
    private static final int lvl2Ry = 187;
    private static final int lvl2H = 8;
    private static final int lvl2V = 2;
    private static final int lvl2UR = 3;
    private static final int lvl2UL = 2;
    private static final int lvl2DR = 2;
    private static final int lvl2DL = 3;
    
    private static final int lvl3Rx = 625;
    private static final int lvl3Ry = 301;
    private static final int lvl3H = 3;
    private static final int lvl3V = 1;
    private static final int lvl3UR = 3;
    private static final int lvl3UL = 2;
    private static final int lvl3DR = 2;
    private static final int lvl3DL = 3;
    
    private static final int lvl4Rx = 483;
    private static final int lvl4Ry = 229;
    private static final int lvl4H = 1;
    private static final int lvl4V = 4;
    private static final int lvl4UR = 2;
    private static final int lvl4UL = 3;
    private static final int lvl4DR = 3;
    private static final int lvl4DL = 2;
    
    private static final int lvl5Rx = 284;
    private static final int lvl5Ry = 200;
    private static final int lvl5H = 3;
    private static final int lvl5V = 2;
    private static final int lvl5UR = 1;
    private static final int lvl5UL = 1;
    private static final int lvl5DR = 1;
    private static final int lvl5DL = 1;
    
    private static final int lvl6Rx = 617;
    private static final int lvl6Ry = 186;
    private static final int lvl6H = 6;
    private static final int lvl6V = 3;
    private static final int lvl6UR = 2;
    private static final int lvl6UL = 1;
    private static final int lvl6DR = 1;
    private static final int lvl6DL = 2;
    
    private static final int lvl7Rx = 619;
    private static final int lvl7Ry = 157;
    private static final int lvl7H = 8;
    private static final int lvl7V = 8;
    private static final int lvl7UR = 4;
    private static final int lvl7UL = 5;
    private static final int lvl7DR = 4;
    private static final int lvl7DL = 3;
    
    private static final int lvl8Rx = 631;
    private static final int lvl8Ry = 227;
    private static final int lvl8H = 4;
    private static final int lvl8V = 6;
    private static final int lvl8UR = 6;
    private static final int lvl8UL = 5;
    private static final int lvl8DR = 5;
    private static final int lvl8DL = 6;
    
    private static final int lvl9Rx = 631;
    private static final int lvl9Ry = 227;
    private static final int lvl9H = 4;
    private static final int lvl9V = 6;
    private static final int lvl9UR = 6;
    private static final int lvl9UL = 5;
    private static final int lvl9DR = 5;
    private static final int lvl9DL = 5;
    
    private static final int lvl10Rx = 548;
    private static final int lvl10Ry = 93;
    private static final int lvl10H = 5;
    private static final int lvl10V = 5;
    private static final int lvl10UR = 4;
    private static final int lvl10UL = 6;
    private static final int lvl10DR = 6;
    private static final int lvl10DL = 4;
    
    //x and y positions of pipe dummies
    public static final int Px = 755;
    public static final int Hy = 30;
    public static final int Vy = 90;
    public static final int URy = 165;
    public static final int ULy = 225;
    public static final int DRy = 285;
    public static final int DLy = 345;
    
    //coordinates for the timer
    public final int timerX = 150;
    public final int timerY = 22;
    
    public static boolean gameOver = false;
    
    //check to scroll the space background
    public static boolean space = false;
    
    //intro stuff
    public static int which;
    public static boolean intro = false;
    public boolean addText = false;
    
    public static int shipX;
    public static int shipY;
    private boolean shipDead;
    
    public static boolean blowUpPipes;
    
    //where power-ups should form
    private final int powerupX = 900;
    
    //this makes the world only add one life powerup for each 1000 points
    private boolean addLife1;
    private boolean addLife2;
    private boolean addLife3;
    private boolean addLife4;
    private boolean addLife5;
    private boolean addLife6;
    private boolean addLife7;
    private boolean addLife8;
    private boolean addLife9;
    private boolean addLife10;
     
    public MyWorld()
    {
        super(800, 400, 1);
        setVars();
        Greenfoot.setSpeed(50);
        Greenfoot.start();
        setPaintOrder(Board.class, Text.class, Ship.class, GameoverBoard.class, Waste.class, RocketUp.class, PipeDummies.class, Pipes.class);
        menu();
    }
    
    public void setVars()
    {
        shipDead = false;
        space = false;
        score = 0;
        which = 0;
        Ship.lives = 5;
        addLife1 = true;
        addLife2 = true;
        addLife3 = true;
        addLife4 = true;
        addLife5 = true;
        addLife6 = true;
        addLife7 = true;
        addLife8 = true;
        addLife9 = true;
        addLife10 = true;
    }
    
    public void intro()
    {
        removeObjects(getObjects(Actor.class));
        setBackground("black.jpg");
        which = 0;
        addObject(new Bg(), 400, 200);
        addObject(new IntroText(), 400, 400);
    }
    
    public void load()
    {
        removeObjects(getObjects(Actor.class));
        GreenfootImage img = new GreenfootImage(800, 400);
        img.fill();
        img.setColor(Color.WHITE);
        img.setFont(new Font("Serif", 1, 72));
        img.drawString("Got Waste?", 215, 75);
        img.setColor(Color.YELLOW);
        img.setFont(new Font("Verdana", 1, 42));
        img.drawString("Load Game", 270, 165);
        setBackground(img);
        addObject(new TextField(), getWidth()/2, getHeight()/2);
        addObject(new Load1(), getWidth()/2, 300);
        addObject(new Back(), 50, 35);
    }
    
    public void controls()
    {
        removeObjects(getObjects(Actor.class));
        GreenfootImage img = new GreenfootImage(800, 400);
        img.fill();
        img.setColor(Color.WHITE);
        img.setFont(new Font("Serif", 1, 72));
        img.drawString("Got Waste?", 215, 75);
        img.setColor(Color.YELLOW);
        img.setFont(new Font("Verdana", 1, 42));
        img.drawString("Controls", 300, 130);
        img.setFont(new Font("Serif", 1, 28));
        img.setColor(Color.GRAY);
        img.drawString("Pipeline", 100, 170);
        img.drawString("Space", 450, 170);
        img.setFont(new Font("Lucida Console", 1, 20));
        img.setColor(Color.WHITE);
        img.drawString("Move pipes: mouse", 50, 200);
        img.drawString("Move ship up: up arrow key", 350, 200);
        img.drawString("Move ship down: down arrow key", 350, 250);
        img.drawString("Fire bullets: space", 350, 300);
        setBackground(img);
        addObject(new Back(), 50, 35);
    }
    
    public void level(int which)
    {
        removeObjects(getObjects(Actor.class));
        this.which = which;
        setBackground("black.jpg");
        space = false;
        addObject(new Bg(), 400, 200);
        addObject(new IntroText(), 400, 400);
    }
    
    public void loadGame()
    {
        if(text.compareTo(pass1) == 0)
        {
            level(10);
        }
        else if(text.compareTo(pass2) == 0)
        {
            level(14);
        }
        else if(text.compareTo(pass3) == 0)
        {
            level(18);
        }
        else if(text.compareTo(pass4) == 0)
        {
            level(22);
        }
        else if(text.compareTo(pass5) == 0)
        {
            level(27);
        }
        else if(text.compareTo(pass6) == 0)
        {
            level(34);
        }
        else if(text.compareTo(pass7) == 0)
        {
            level(39);
        }
        else if(text.compareTo(pass8) == 0)
        {
            level(43);
        }
        else if(text.compareTo(pass9) == 0)
        {
            level(48);
        }
        else if(text.compareTo(pass10) == 0)
        {
            level(53);
        }
        else
        {
            text = "Incorrect Password";
        }
    }

    public void menu()
    {
        removeObjects(getObjects(Actor.class));
        space = false;
        score = 0;
        Ship.lives = 5;
        GreenfootImage img = new GreenfootImage(800, 400);
        img.fill();
        img.setColor(Color.WHITE);
        img.setFont(new Font("Serif", 1, 72));
        img.drawString("Got Waste?", 215, 75);
        setBackground(img);
        addObject(new Play(), getWidth()/2, 150);
        addObject(new Load(), getWidth()/2, 250);
        addObject(new Controls(), getWidth()/2, 350);
    }
    
    public void setScore(int s)
    {
        score = s;
    }
    
    public void powerups()
    {
        if(score >= 1000 && addLife1)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 2000 && addLife2)
        {
            addLife2 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 3000 && addLife3)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 4000 && addLife4)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 5000 && addLife5)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 6000 && addLife6)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 7000 && addLife7)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 8000 && addLife8)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 9000 && addLife9)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        if(score >= 10000 && addLife10)
        {
            addLife1 = false;
            addObject(new Life(), powerupX, Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
    }
    
    public void space1()
    {
        for(int i = 0; i<enemies1; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(3)+1, Greenfoot.getRandomNumber(3)+2), i*Greenfoot.getRandomNumber(300)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        }
        
    }
    public void space2()
    {
        for(int i = 0; i<enemies2; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(3)+2, Greenfoot.getRandomNumber(3)+3), i*Greenfoot.getRandomNumber(300)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    public void space3()
    {
        for(int i = 0; i<enemies3; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(3)+3, Greenfoot.getRandomNumber(3)+4), i*Greenfoot.getRandomNumber(600)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    public void space4()
    {
        for(int i = 0; i<enemies4; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(3)+3, Greenfoot.getRandomNumber(3)+4), i*Greenfoot.getRandomNumber(600)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    public void space5()
    {
        for(int i = 0; i<enemies5; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(3)+4, Greenfoot.getRandomNumber(3)+4), i*Greenfoot.getRandomNumber(600)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    public void space6()
    {
        for(int i = 0; i<enemies6; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(3)+4, Greenfoot.getRandomNumber(3)+4), i*Greenfoot.getRandomNumber(600)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    public void space7()
    {
        for(int i = 0; i<enemies7; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(3)+4, Greenfoot.getRandomNumber(3)+4), i*Greenfoot.getRandomNumber(600)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    public void space8()
    {
        for(int i = 0; i<enemies8; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(4)+4, Greenfoot.getRandomNumber(3)+5), i*Greenfoot.getRandomNumber(650)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    public void space9()
    {
        for(int i = 0; i<enemies9; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(4)+4, Greenfoot.getRandomNumber(3)+5), i*Greenfoot.getRandomNumber(650)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    public void space10()
    {
        for(int i = 0; i<enemies10; i++)
        {
            addObject(new Enemy(Greenfoot.getRandomNumber(5)+4, Greenfoot.getRandomNumber(4)+5), i*Greenfoot.getRandomNumber(1200)+getWidth(), Greenfoot.getRandomNumber(getHeight()-100)+60);
        } 
    }
    
    public void showSolution(int lvl)
    {
        removeObjects(getObjects(Actor.class));
        solutionPressed = true;
        drawOilBg();
        blowUpPipes = false;
        if(lvl == 1)
        {
            level1();
            for(int i = 0; i<8; i++)
            {
                addObject(new Horizantal(), i*65+65, 200);
            }
         }
        if(lvl ==2)
        {
            level2();
            addObject(new DownLeft(), 59, 208);
            addObject(new UpRight(), 79, 253);
            addObject(new Horizantal(), 139, 262);
            addObject(new Horizantal(), 204, 262);
            addObject(new Horizantal(), 269, 262);
            addObject(new UpLeft(), 324, 252);
            addObject(new Vertical(), 333, 192);
            addObject(new DownRight(), 341, 134);
            addObject(new Horizantal(), 396, 124);
            addObject(new Horizantal(), 461, 124);
            addObject(new DownLeft(), 521, 132);
            addObject(new UpRight(), 541, 179); 
        }
        if(lvl == 3)
        {
            level3();
            addObject(new Horizantal(), 65, 200);
            addObject(new Horizantal(), 130, 200);
            addObject(new UpLeft(), 185, 190);
            addObject(new DownRight(), 202, 135);
            addObject(new DownLeft(), 252, 133);
            addObject(new UpRight(), 272, 178);
            addObject(new DownLeft(), 327, 195);
            addObject(new Vertical(), 337, 250);
            addObject(new UpRight(), 347, 305);
            addObject(new Horizantal(), 407, 314);
            addObject(new UpLeft(), 462, 304);
            addObject(new DownRight(), 479, 249);
            addObject(new DownLeft(), 529, 247);
            addObject(new UpRight(), 549, 292);
        }
        if(lvl == 4)
        {
            level4();
            addObject(new UpLeft(), 55, 190);
            addObject(new UpLeft(), 192, 371);
            addObject(new UpLeft(), 329, 357);
            addObject(new DownRight(), 72, 135);
            addObject(new DownRight(), 209, 316);
            addObject(new DownRight(), 346, 239);
            addObject(new DownLeft(), 122, 133);
            addObject(new DownLeft(), 259, 314);
            addObject(new Vertical(), 132, 188);
            addObject(new Vertical(), 132, 253);
            addObject(new Vertical(), 132, 318);
            addObject(new Vertical(), 338, 297);
            addObject(new UpRight(), 142, 373);
            addObject(new UpRight(), 279, 359);
            addObject(new Horizantal(), 401, 229);
        }
        if(lvl == 5)
        {
            level5();
            addObject(new DownLeft(), 59, 208);
            addObject(new Vertical(), 69, 263);
            addObject(new UpRight(), 79, 318);
            addObject(new Horizantal(), 139, 327);
            addObject(new UpLeft(), 194, 317);
            addObject(new Vertical(), 203, 257);
            addObject(new DownRight(), 211, 199);
        }
        if(lvl == 6)
        {
            level6();
            addObject(new DownLeft(), 59, 208);
            addObject(new Vertical(), 69, 263);
            addObject(new UpRight(), 79, 318);
            addObject(new Horizantal(), 139, 327);
            addObject(new Horizantal(), 204, 327);
            addObject(new UpLeft(), 259, 317);
            addObject(new Vertical(), 269, 257);
            addObject(new Vertical(), 269, 192);
            addObject(new DownRight(), 277, 134);
            addObject(new Horizantal(), 332, 124);
            addObject(new Horizantal(), 397, 124);
            addObject(new Horizantal(), 462, 124);
            addObject(new DownLeft(), 521, 132);
            addObject(new UpRight(), 541, 177);
        }
        if(lvl == 7)
        {
            level7();
            addObject(new UpLeft(), 55, 190);
            addObject(new UpLeft(), 192, 374);
            addObject(new UpLeft(), 329, 360);
            addObject(new UpLeft(), 466, 284);
            addObject(new Vertical(), 64, 131);
            addObject(new Vertical(), 132, 126);
            addObject(new Vertical(), 132, 191);
            addObject(new Vertical(), 132, 256);
            addObject(new Vertical(), 132, 321);
            addObject(new Vertical(), 338, 301);
            addObject(new Vertical(), 475, 225);
            addObject(new DownRight(), 72, 73);
            addObject(new DownRight(), 209, 319);
            addObject(new DownRight(), 346, 243);
            addObject(new DownRight(), 483, 167);
            addObject(new UpRight(), 142, 376);
            addObject(new UpRight(), 279, 362);
            addObject(new UpRight(), 416, 286);
            addObject(new DownLeft(), 122, 71);
            addObject(new DownLeft(), 259, 317);
            addObject(new DownLeft(), 396, 241);
            addObject(new Horizantal(), 538, 157);
        }
        if(lvl == 8)
        {
            level8();
            addObject(new UpLeft(), 266, 302);
            addObject(new UpLeft(), 129, 316);
            addObject(new UpLeft(), 393, 165);
            addObject(new Vertical(), 69, 263);
            addObject(new Vertical(), 275, 243);
            addObject(new Vertical(), 402, 106);
            addObject(new Vertical(), 470, 101);
            addObject(new DownRight(), 146, 261);
            addObject(new DownRight(), 283, 185);
            addObject(new DownRight(), 410, 48);
            addObject(new UpRight(), 79, 318);
            addObject(new UpRight(), 216, 304);
            addObject(new UpRight(), 480, 156);
            addObject(new UpRight(), 555, 218);
            addObject(new DownLeft(), 59, 208);
            addObject(new DownLeft(), 196, 259);
            addObject(new DownLeft(), 460, 46);
            addObject(new DownLeft(), 535, 173);
            addObject(new Horizantal(), 338, 175);
        }
        if(lvl == 9)
        {
            level9();
            addObject(new UpLeft(), 331, 241);
            addObject(new UpLeft(), 129, 316);
            addObject(new UpLeft(), 468, 230);
            addObject(new Vertical(), 69, 263);
            addObject(new Vertical(), 138, 257);
            addObject(new Vertical(), 340, 182);
            addObject(new Vertical(), 408, 177);
            addObject(new DownRight(), 146, 199);
            addObject(new DownRight(), 348, 124);
            addObject(new DownRight(), 485, 175);
            addObject(new UpRight(), 79, 318);
            addObject(new UpRight(), 216, 242);
            addObject(new UpRight(), 555, 218);
            addObject(new UpRight(), 418, 232);
            addObject(new DownLeft(), 59, 208);
            addObject(new DownLeft(), 196, 197);
            addObject(new DownLeft(), 398, 122);
            addObject(new DownLeft(), 535, 173);
            addObject(new Horizantal(), 276, 251);
        }
        if(lvl == 10)
        {
            level10();
            addObject(new UpLeft(), 194, 317);
            addObject(new UpLeft(), 258, 242);
            addObject(new UpLeft(), 395, 361);
            addObject(new UpLeft(), 459, 286);
            addObject(new Vertical(), 69, 263);
            addObject(new Vertical(), 267, 183);
            addObject(new Vertical(), 335, 178);
            addObject(new Vertical(), 335, 243);
            addObject(new Vertical(), 335, 308);
            addObject(new Vertical(), 467, 226);
            addObject(new Vertical(), 467, 161);
            addObject(new DownRight(), 211, 262);
            addObject(new DownRight(), 275, 125);
            addObject(new DownRight(), 412, 306);
            addObject(new DownRight(), 475, 103);
            addObject(new UpRight(), 79, 318);
            addObject(new UpRight(), 345, 363);
            addObject(new DownLeft(), 59, 208);
            addObject(new DownLeft(), 325, 123);
            addObject(new Horizantal(), 139, 327);
        }
    }
    
    public void oilWin(int lvl)
    {
        removeObjects(getObjects(Actor.class));
        drawSpaceBg();
        if(lvl == 1)
        {
            space1();
        }
        if(lvl == 2)
        {
            space2();
        }
        if(lvl == 3)
        {
            space3();
        }
        if(lvl == 4)
        {
            space4();
        }
        if(lvl == 5)
        {
            space5();
        }
        if(lvl == 6)
        {
            space6();
        }
        if(lvl == 7)
        {
            space7();
        }
        if(lvl == 8)
        {
            space8();
        }
        if(lvl == 9)
        {
            space9();
        }
        if(lvl == 10)
        {
            space10();
        }
    }
    
    public void spaceWin(int lvl)
    {
        
        if(lvl == 1)
        {
            removeObjects(getObjects(Actor.class));
            level(14);
        }
        if(lvl == 2)
        {
            removeObjects(getObjects(Actor.class));
            level(18);
        }
        if(lvl == 3)
        {
            removeObjects(getObjects(Actor.class));
            level(22);
        }
        if(lvl == 4)
        {
            removeObjects(getObjects(Actor.class));
            level(27);
        }
        if(lvl == 5)
        {
            removeObjects(getObjects(Actor.class));
            level(34);
        }
        if(lvl == 6)
        {
            removeObjects(getObjects(Actor.class));
            level(39);
        }
        if(lvl == 7)
        {
            removeObjects(getObjects(Actor.class));
            level(43);
        }
        if(lvl == 8)
        {
            removeObjects(getObjects(Actor.class));
            level(48);
        }
        if(lvl == 9)
        {
            removeObjects(getObjects(Actor.class));
            level(53);
        }
        if(lvl == 10)
        {
            removeObjects(getObjects(Actor.class));
            level(59);
        }
    }
    
    public void done(int lvl)
    {
            movePipes = false;
            timerCount = false;
            List<Beg> begs = getObjects(Beg.class);
            for(Actor a : begs)
            {
                addObject(new Waste(), -9, a.getY());
            }
    }
    
    public void drawOilBg()
    {
        removeObjects(getObjects(Actor.class));
        blowUpPipes = true;
        space = false;
        timerCount = true;
        oilWin = false;
        addObject(new HorizantalCounter(), 715, Hy);
        addObject(new VerticalCounter(), 715, Vy);
        addObject(new UpLeftCounter(), 715, ULy);
        addObject(new DownRightCounter(), 715, DRy);
        addObject(new DownLeftCounter(), 715, DLy);
        addObject(new UpRightCounter(), 715, URy);
        addObject(new Menu(), 50, 20);
        addObject(new Score("Score: "), 325, 20);
        addObject(new Clear(), 590, 20);
        addObject(new Done(), 660, 20);
        addObject(new Solution(), 510, 20);
        setBackground(bg);
        addObject(new Side(), 750, 200);
        addObject(new Beg(), 0, 200);
        addObject(new Level(), 50, 390);
        addObject(new Password(), 150, 390);
        movePipes = true;
    }
    
    public void oilClear(int lvl)
    {
            removeObjects(getObjects(Actor.class));
            drawOilBg();
            Greenfoot.setSpeed(50);
            if(lvl == 1)
            {
                level1();
            }
            if(lvl == 2)
            {
                level2();
            }
            if(lvl == 3)
            {
                level3();
            }
            if(lvl == 4)
            {
                level4();
            }
            if(lvl == 5)
            {
                level5();
            }
            if(lvl == 6)
            {
                level6();
            }
            if(lvl == 7)
            {
                level7();
            }
            if(lvl == 8)
            {
                level8();
            }
            if(lvl == 9)
            {
                level9();
            }
            if(lvl == 10)
            {
                level10();
            }
    }
    
    public void level1()
    {
        currentLvl = 1;
        timerValue = timer1-1;
        addObject(new Timer("Time: ", timer1), timerX, timerY);
        addObject(new RocketUp(), lvl1Rx, lvl1Ry);
        for(int i = 0; i<lvl1H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl1H; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl1H; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl1H; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl1H; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl1H; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level2()
    {
        currentLvl = 2;
        timerValue = timer2-1;
        addObject(new Timer("Time: ", timer2), timerX, timerY);
        addObject(new RocketUp(), lvl2Rx, lvl2Ry);
        //obstacles
        addObject(new Obstacle(), 140, 211);
        addObject(new Obstacle(), 200, 211);
        addObject(new Obstacle(), 260, 211);
        addObject(new Obstacle(), 400, 176);
        addObject(new Obstacle(), 460, 176);
        addObject(new Obstacle(), 645, 91);
        addObject(new Obstacle(), 645, 281);
        addObject(new Obstacle(), 645, 355);
        for(int i = 0; i<lvl2H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl2V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl2UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl2DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl2DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl2UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level3()
    {
        currentLvl = 3;
        timerValue = timer3-1;
        addObject(new Timer("Time: ", timer3), timerX, timerY);
        addObject(new RocketUp(), lvl3Rx, lvl3Ry);
        //obstacles
        addObject(new Obstacle(), 45, 70);
        addObject(new Obstacle(), 45, 140);
        addObject(new Obstacle(), 45, 265);
        addObject(new Obstacle(), 45, 325);
        addObject(new Obstacle(), 230, 65);
        addObject(new Obstacle(), 210, 350);
        addObject(new Obstacle(), 410, 370);
        addObject(new Obstacle(), 430, 110);
        addObject(new Obstacle(), 510, 110);
        addObject(new Obstacle(), 590, 110);
        addObject(new Obstacle(), 610, 250);
        for(int i = 0; i<lvl3H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl3V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl3UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl3DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl3DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl3UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level4()
    {
        currentLvl = 4;
        timerValue = timer4-1;
        addObject(new Timer("Time: ", timer4), timerX, timerY);
        addObject(new RocketUp(), lvl4Rx, lvl4Ry);
        //obstacles
        addObject(new Obstacle(), 35, 265);
        addObject(new Obstacle(), 35, 350);
        addObject(new Obstacle(), 238, 250);
        addObject(new Obstacle(), 300, 60);
        addObject(new Obstacle(), 400, 362);
        addObject(new Obstacle(), 660, 80);
        addObject(new Obstacle(), 660, 170);
        addObject(new Obstacle(), 660, 260);
        addObject(new Obstacle(), 660, 350);
        for(int i = 0; i<lvl4H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl4V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl4UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl4DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl4DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl4UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level5()
    {
        currentLvl = 5;
        timerValue = timer5-1;
        addObject(new Timer("Time: ", timer5), timerX, timerY);
        addObject(new RocketUp(), lvl5Rx, lvl5Ry);
        //obstacles
        addObject(new Obstacle(), 135, 128);
        addObject(new Obstacle(), 135, 280);
        addObject(new Obstacle(), 280, 120);
        addObject(new Obstacle(), 280, 285);
        addObject(new Obstacle(), 385, 200);
        addObject(new Obstacle(), 626, 99);
        addObject(new Obstacle(), 553, 274);
        //mines
        addObject(new Mine(), 137, 209);
        for(int i = 0; i<lvl5H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl5V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl5UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl5DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl5DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl5UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level6()
    {
        currentLvl = 6;
        timerValue = timer6-1;
        addObject(new Timer("Time: ", timer6), timerX, timerY);
        addObject(new RocketUp(), lvl6Rx, lvl6Ry);
        //obstacles
        if(!solutionPressed)
        {
            addObject(new Obstacle(), 100, 272);
            addObject(new Obstacle(), 375, 125);
            addObject(new Obstacle(), 375, 50);
            addObject(new Obstacle(), 545, 130);
        }
        addObject(new Obstacle(), 100, 128);
        addObject(new Obstacle(), 185, 200);
        addObject(new Obstacle(), 375, 200);
        addObject(new Obstacle(), 375, 275);
        addObject(new Obstacle(), 375, 350);
        addObject(new Obstacle(), 450, 200);
        
        addObject(new Obstacle(), 545, 275);
        //mines
        addObject(new Mine(), 498, 36);
        addObject(new Mine(), 95, 388);
        for(int i = 0; i<lvl6H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl6V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl6UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl6DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl6DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl6UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level7()
    {
        currentLvl = 7;
        timerValue = timer7-1;
        addObject(new Timer("Time: ", timer7), timerX, timerY);
        addObject(new RocketUp(), lvl7Rx, lvl7Ry);
        //obstacles
        if(!solutionPressed)
        {
            for(int i = 0; i<4; i++)
            {
                addObject(new Obstacle(), i*70+240, 185);
            }
            for(int i = 0; i<4; i++)
            {
                addObject(new Obstacle(), i*70+240, 265);
            }
            for(int i = 0; i<4; i++)
            {
                addObject(new Obstacle(), i*70+240, 335);
            }

        }
        addObject(new Obstacle(), 50, 260);
        addObject(new Obstacle(), 50, 335);
        addObject(new Obstacle(), 640, 245);
        //mines
        addObject(new Mine(), 350, 269);
        for(int i = 0; i<4; i++)
        {
            addObject(new Mine(), 355, i*25+35);
        }
        for(int i = 0; i<lvl7H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl7V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl7UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl7DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl7DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl7UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level8()
    {
        currentLvl = 8;
        timerValue = timer8-1;
        addObject(new Timer("Time: ", timer8), timerX, timerY);
        addObject(new RocketUp(), lvl8Rx, lvl8Ry);
        //obstacles
        addObject(new Obstacle(), 512, 357);
        addObject(new Obstacle(), 35, 90);
        //mines
        addObject(new Mine(), 110, 213);
        addObject(new Mine(), 146, 214);
        addObject(new Mine(), 191, 212);
        addObject(new Mine(), 236, 214);
        addObject(new Mine(), 288, 137);
        addObject(new Mine(), 211, 193);
        addObject(new Mine(), 359, 137);
        addObject(new Mine(), 322, 222);
        addObject(new Mine(), 370, 224);
        addObject(new Mine(), 417, 223);
        addObject(new Mine(), 452, 222);
        addObject(new Mine(), 506, 218);
        addObject(new Mine(), 562, 271);
        addObject(new Mine(), 272, 371);
        addObject(new Mine(), 229, 370);
        addObject(new Mine(), 175, 367);
        addObject(new Mine(), 138, 367);
        addObject(new Mine(), 80, 367);
        addObject(new Mine(), 49, 367);
        addObject(new Mine(), 89, 75);
        addObject(new Mine(), 308, 60);
        addObject(new Mine(), 41, 108);
        addObject(new Mine(), 690, 77);
        addObject(new Mine(), 641, 141);
        addObject(new Mine(), 518, 87);
        addObject(new Mine(), 614, 316);
        addObject(new Mine(), 610, 355);
        addObject(new Mine(), 496, 287);
        addObject(new Mine(), 442, 328);
        for(int i = 0; i<lvl8H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl8V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl8UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl8DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl8DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl8UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level9()
    {
        currentLvl = 9;
        timerValue = timer9-1;
        addObject(new Timer("Time: ", timer9), timerX, timerY);
        addObject(new RocketUp(), lvl9Rx, lvl9Ry);
        //obstacles
        addObject(new Obstacle(), 175, 140);
        addObject(new Obstacle(), 440, 350);
        addObject(new Obstacle(), 635, 330);
        addObject(new Obstacle(), 650, 115);
        addObject(new Obstacle(), 520, 115);
        //mines
        addObject(new Mine(), 106, 215);
        addObject(new Mine(), 108, 255);
        addObject(new Mine(), 108, 293);
        addObject(new Mine(), 109, 153);
        addObject(new Mine(), 110, 120);
        addObject(new Mine(), 109, 67);
        addObject(new Mine(), 213, 71);
        addObject(new Mine(), 294, 68);
        addObject(new Mine(), 435, 68);
        addObject(new Mine(), 620, 73);
        addObject(new Mine(), 443, 186);
        addObject(new Mine(), 514, 216);
        addObject(new Mine(), 381, 155);
        addObject(new Mine(), 378, 240);
        for(int i = 0; i<lvl9H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl9V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl9UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl9DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl9DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl9UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    public void level10()
    {
        currentLvl = 10;
        timerValue = timer10-1;
        addObject(new Timer("Time: ", timer10), timerX, timerY);
        addObject(new RocketUp(), lvl10Rx, lvl10Ry);
        //obstacles
        if(!solutionPressed)
        {
            addObject(new Obstacle(), 84, 322);
            addObject(new Obstacle(), 201, 325);
            addObject(new Obstacle(), 341, 292);
            addObject(new Obstacle(), 449, 300);
        }
        addObject(new Obstacle(), 537, 370);
        addObject(new Obstacle(), 663, 367);
        addObject(new Obstacle(), 647, 222);
        addObject(new Obstacle(), 638, 155);
        addObject(new Obstacle(), 647, 77);
        addObject(new Obstacle(), 37, 62);
        addObject(new Obstacle(), 125, 62);
        addObject(new Obstacle(), 217, 62);
        addObject(new Obstacle(), 311, 62);
        addObject(new Obstacle(), 410, 62);
        addObject(new Obstacle(), 125, 190);
        addObject(new Obstacle(), 217, 190);
        //mines
        addObject(new Mine(), 397, 130);
        addObject(new Mine(), 140, 264);
        addObject(new Mine(), 305, 166);
        addObject(new Mine(), 275, 310);
        addObject(new Mine(), 456, 344);
        addObject(new Mine(), 405, 152);
        addObject(new Mine(), 406, 200);
        addObject(new Mine(), 408, 246);
        addObject(new Mine(), 588, 190);
        for(int i = 0; i<lvl10H; i++)
        {
            addObject(new HorizantalDummy(), Px, Hy);
        }
        for(int i = 0; i<lvl10V; i++)
        {
            addObject(new VerticalDummy(), Px, Vy);
        }
        for(int i = 0; i<lvl10UL; i++)
        {
            addObject(new UpLeftDummy(), Px, ULy);
        }
        for(int i = 0; i<lvl10DR; i++)
        {
            addObject(new DownRightDummy(), Px, DRy);
        }
        for(int i = 0; i<lvl10DL; i++)
        {
            addObject(new DownLeftDummy(), Px, DLy);
        }
        for(int i = 0; i<lvl10UR; i++)
        {
            addObject(new UpRightDummy(), Px, URy);
        }
    }
    
    public void drawSpaceBg()
    {
        GreenfootImage background = new GreenfootImage(800, 400);
        scrollingImage = getScrollingImage(800, 400);
        background.drawImage(scrollingImage, 0, 0);
        setBackground(background);
        space = true;
        shipDead = false;
        addObject(new Menu(), 50, 20);
        addObject(new Lives("Lives: "), 150, 23);
        addObject(new Score("Score: "), 325, 20);
        addObject(new Ship(false), 50, getHeight()/2);
        addObject(new Level(), 50, 390);
        addObject(new Password(), 150, 390);
        Greenfoot.setSpeed(50);
    }
    /*
    public void stopped()
    {
         Greenfoot.start();
    }*/
    
    public void act()
    {
        if(space)
        {
            if(getObjects(Ship.class).size() == 0 & getObjects(Explosion.class).size() == 0)
            {
                if(Ship.lives > 0){
                addObject(new Ship(false), shipX, shipY);
                }
                else if(!shipDead)
                {
                    shipDead = true;
                    addObject(new GameoverBoard("The Martians got you!"), getWidth()/2, getHeight()/2);
                }
            }
            scroll();
            powerups();
        }
    }
  
    
    public void scroll()
    {
        if(scrollSpeed > 0 && scrollPosition <= 0) {
            scrollPosition = getWidth();
        }
        if(scrollSpeed < 0 && scrollPosition >= getWidth()) {
            scrollPosition = 0;
        }
        scrollPosition -= scrollSpeed;
        paint(scrollPosition);
    }
    
    
    /**
     * Paint scrolling image at given position and make sure the rest of
     * the background is also painted with the same image.
     */
    private void paint(int position)
    {
        GreenfootImage bg = getBackground();
        bg.drawImage(scrollingImage, position, 0);
        bg.drawImage(scrollingImage, position - scrollingImage.getWidth(), 0);
    }
 
    /**
     * Returns an image with the given dimensions.
     */
    private GreenfootImage getScrollingImage(int width, int height)
    {
        GreenfootImage image = new GreenfootImage(width, height);
        for(int x = 0; x < width; x += bgImage.getWidth()) {
            for(int y = 0; y < height; y += bgImage.getHeight()) {
                image.drawImage(bgImage, x, y);
            }
        }
        return image;
    }  
}
