import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
import java.awt.Color;
/**
 * Write a description of class Board here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GameoverBoard  extends Actor
{
    private GreenfootImage img = new GreenfootImage("boardBg.png");
    private String text;
    private boolean opaque;
    private boolean clicked;

    public GameoverBoard(String text)
    { 
        MyWorld.movePipes = false;
        img.setFont(new Font("Serif", 1, 72));
        img.setColor(Color.WHITE);
        img.drawString("Oops!", 15, 100);
        img.setFont(new Font("Serif", 1, 40));
        img.drawString(text, 15, 155);
        img.setColor(Color.YELLOW);
        img.drawString("Score: "+MyWorld.score, 15, 200);
        img.setColor(Color.WHITE);
        img.setFont(new Font("Serif", 1, 18));
        img.drawString("Click to continue...", 300, 200);
        img.setTransparency(0);
        opaque = false;
        clicked = false;
    }


    public void act() 
    {
        if(opaque == false)
        {
            if(img.getTransparency() == 255)
            {
                opaque = true;
            }
            else
            {
                img.setTransparency(img.getTransparency()+5);
                setImage(img);
            }
        }
        if(clicked)
        {
            if(opaque == true)
            {
                if(img.getTransparency() == 0)
                {
                    opaque = false;
                    MyWorld world = (MyWorld) getWorld();
            world.menu();
                }
                else
                {
                    img.setTransparency(img.getTransparency()-5);
                    setImage(img);
                }
            }
            
        }
        if(Greenfoot.mouseClicked(this))
        {
            clicked = true;
        }
    }    
}
