import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Vertical here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Vertical  extends Pipes
{
    public Vertical(int i)
   {
       Greenfoot.playSound("build.wav");
    }
    
    public Vertical()
    {}
    
    public void snap()
    {
        Actor ul = getOneObjectAtOffset(0, 50, UpLeft.class);
        Actor dl = getOneObjectAtOffset(0, -50, DownLeft.class);
        Actor v = getOneObjectAtOffset(0, -50, Vertical.class);
        if(ul != null)
        {
            setLocation(ul.getX()+9, ul.getY()-59);
        }
        if(dl != null)
        {
            setLocation(dl.getX()+10, dl.getY()+55);
        }
        if(v != null)
        {
            setLocation(v.getX(), v.getY()+65);
        }
    }
    
    public void act() 
    {
        checkMouse();
        snap();
        outsideField();
    }    
    
    public void outsideField()
    {
        Actor o = getOneIntersectingObject(Obstacle.class);
        if(getX() >= 700-getImage().getWidth()/2 || o != null)
        {
            getWorld().addObject(new VerticalDummy(), MyWorld.Px, MyWorld.Vy);
            getWorld().removeObject(this);
        }
    }
    
    public void checkMouse()
    {
        if(Greenfoot.mouseDragged(this) && MyWorld.movePipes)
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            setLocation(mouse.getX(), mouse.getY());
        }
    } 
}
